package com.landray.kmss.sys.attachment.service.spring;

import java.util.ArrayList;
import com.landray.kmss.sys.attachment.dao.ISysAttMainCoreInnerDao;
import org.apache.commons.beanutils.BeanUtils;
import org.hibernate.Hibernate;
import com.landray.kmss.sys.log.util.oper.IUserOper;
import com.landray.kmss.sys.log.util.oper.IUserDetailOper;
import java.io.InputStream;
import java.util.HashMap;
import com.landray.kmss.sys.log.util.UserOperConvertHelper;
import com.landray.kmss.sys.log.util.UserOperHelper;
import com.landray.kmss.sys.lbpmservice.support.forms.LbpmProcessMainForm;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.util.AutoArrayList;
import java.util.List;
import java.util.Iterator;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import com.landray.kmss.sys.attachment.forms.AttachmentDetailsForm;
import com.landray.kmss.util.ModelUtil;
import com.landray.kmss.util.AutoHashMap;
import java.util.Map;
import com.landray.kmss.sys.attachment.forms.IAttachmentForm;
import com.landray.kmss.common.actions.RequestContext;
import com.landray.kmss.common.forms.IExtendForm;
import com.landray.kmss.sys.attachment.model.IAttachment;
import com.landray.kmss.common.model.IBaseModel;
import org.springframework.beans.BeansException;
import org.slf4j.LoggerFactory;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import org.slf4j.Logger;
import org.springframework.context.ApplicationContext;
import com.landray.kmss.common.service.ICoreOuterService;
import com.landray.kmss.sys.attachment.service.ISysAttachmentService;
import org.springframework.context.ApplicationContextAware;
import com.landray.kmss.common.service.BaseCoreOuterServiceImp;

public class SysAttachmentCoreOuterService extends BaseCoreOuterServiceImp implements ApplicationContextAware, ISysAttachmentService, ICoreOuterService
{
    ApplicationContext ctx;
    private static final Logger logger;
    protected ISysAttMainCoreInnerService sysAttMainService;
    
    static {
        logger = LoggerFactory.getLogger(SysAttachmentCoreOuterService.class);
    }
    
    public SysAttachmentCoreOuterService() {
        this.ctx = null;
    }
    
    public void setApplicationContext(final ApplicationContext ctx) throws BeansException {
        this.ctx = ctx;
    }
    
    public ISysAttMainCoreInnerService getSysAttMainService() {
        if (this.sysAttMainService == null) {
            this.sysAttMainService = (ISysAttMainCoreInnerService)this.ctx.getBean("sysAttMainService");
        }
        return this.sysAttMainService;
    }
    
    public void setSysAttMainService(final ISysAttMainCoreInnerService sysAttMainService) {
        this.sysAttMainService = sysAttMainService;
    }
    
    public void delete(final IBaseModel mainModel) throws Exception {
        if (mainModel instanceof IAttachment) {
            this.getSysAttMainService().deleteCoreModels(mainModel);
            super.delete(mainModel);
        }
    }
    
    public void convertModelToForm(final IExtendForm form, final IBaseModel model, final RequestContext requestContext) throws Exception {
        if (model == null || model.getFdId() == null) {
            return;
        }
        if (form instanceof IAttachmentForm && model instanceof IAttachment) {
            this.addAttachment((IAttachment)form, (IAttachment)model);
        }
    }
    
    public void convertFormToModel(final IExtendForm form, final IBaseModel model, final RequestContext requestContext) throws Exception {
        if (form instanceof IAttachmentForm && model instanceof IAttachment) {
            final IAttachmentForm attachmentForm = (IAttachmentForm)form;
            final IAttachment attachment = (IAttachment)model;
            final AutoHashMap attachmentForms = attachmentForm.getAttachmentForms();
            attachment.getAttachmentForms().putAll((Map)attachmentForms);
        }
    }
    
    public void addAttachment(final IAttachment form, final IAttachment model) throws Exception {
        this.addAttachment(form, model, null, true);
    }
    
    public void addAttachment(final IAttachment form, final IAttachment model, final String fdKey) throws Exception {
        this.addAttachment(form, model, fdKey, false);
    }
    
    public Map getCloneAttachmentMap(final IAttachment attachment, final String targetModelName) throws Exception {
        return this.getCloneAttachmentMapForModel(attachment, targetModelName, null, null, true);
    }
    
    public Map getCloneAttachmentMapForModel(final IAttachment attachment, final String targetModelName, final IBaseModel model) throws Exception {
        return this.getCloneAttachmentMapForModel(attachment, targetModelName, model, null, true);
    }
    
    public Map getCloneAttachmentMapForModel(final IAttachment attachment, final String targetModelName, final IBaseModel model, final String fdKey) throws Exception {
        return this.getCloneAttachmentMapForModel(attachment, targetModelName, model, fdKey, false);
    }
    
    public void updateCloneAttachmentMap(final IAttachment attachment) throws Exception {
        final String modelClassName = ModelUtil.getModelClassName((Object)attachment);
        final String modelId = ((IBaseModel)attachment).getFdId();
        final Map forms = (Map)attachment.getAttachmentForms();
        for (final String key : forms.keySet()) {
            if (key != null) {
                final AttachmentDetailsForm attachmentForm = forms.get(key);
                if (attachmentForm.getAttachments() == null) {
                    continue;
                }
                final List atts = (List)attachmentForm.getAttachments();
                for (int i = 0; i < atts.size(); ++i) {
                    final SysAttMain sysAttMain = atts.get(i);
                    sysAttMain.setFdKey(key);
                    sysAttMain.setFdModelId(modelId);
                    sysAttMain.setFdModelName(modelClassName);
                    this.getSysAttMainService().update((IBaseModel)sysAttMain);
                }
            }
        }
    }
    
    public void cloneModelToForm(final IExtendForm form, final IBaseModel model, final RequestContext requestContext) throws Exception {
        if (model == null || model.getFdId() == null) {
            return;
        }
        if (form instanceof IAttachmentForm && model instanceof IAttachment) {
            this.addAttachment((IAttachment)form, (IAttachment)model);
            final String modelClassName = ModelUtil.getModelClassName((Object)model);
            final IAttachmentForm attachmentForm = (IAttachmentForm)form;
            final Map attForms = (Map)attachmentForm.getAttachmentForms();
            final String isNewFile = requestContext.getParameter("isNewFile");
            for (final String key : attForms.keySet()) {
                final AttachmentDetailsForm attForm = attForms.get(key);
                attForm.setFdModelName(modelClassName);
                attForm.setFdKey(key);
                final List atts = (List)attForm.getAttachments();
                String attids = "";
                final AutoArrayList attachments = new AutoArrayList((Class)SysAttMain.class);
                final Iterator iter = atts.iterator();
                while (iter.hasNext()) {
                    SysAttMain sysAttMain = iter.next();
                    if ("historyVersionAttachment".equals(sysAttMain.getFdKey())) {
                        continue;
                    }
                    if (StringUtil.isNotNull(isNewFile) && "true".equalsIgnoreCase(isNewFile)) {
                        sysAttMain = this.getSysAttMainService().clone(sysAttMain, Boolean.valueOf(true));
                    }
                    else {
                        sysAttMain = this.getSysAttMainService().clone(sysAttMain);
                    }
                    sysAttMain.setFdVersion(Integer.valueOf(1));
                    sysAttMain.setDownloadSum(Integer.valueOf(0));
                    attids = String.valueOf(attids) + sysAttMain.getFdId().toString();
                    if (iter.hasNext()) {
                        attids = String.valueOf(attids) + ";";
                    }
                    attachments.add((Object)sysAttMain);
                }
                attForm.setAttachments(attachments);
                attForm.setAttachmentIds(attids);
            }
        }
    }
    
    protected void save(final IBaseModel model) throws Exception {
        if (model instanceof IAttachment) {
            final IAttachment attachment = (IAttachment)model;
            final String modelClassName = ModelUtil.getModelClassName((Object)model);
            final String modelId = model.getFdId();
            final Map forms = (Map)attachment.getAttachmentForms();
            this.saveAtt(forms, modelId, modelClassName);
        }
    }
    
    public void saveByLbpmForm(final LbpmProcessMainForm lbpmProcessForm) throws Exception {
        final String modelClassName = lbpmProcessForm.getSysWfBusinessForm().getFdModelName();
        final String modelId = lbpmProcessForm.getSysWfBusinessForm().getFdModelId();
        final Map forms = (Map)lbpmProcessForm.getAttachmentForms();
        this.saveAtt(forms, modelId, modelClassName);
    }
    
    public void saveApi(final IBaseModel model) throws Exception {
        this.save(model);
    }
    
    private void saveAtt(final Map forms, final String modelId, final String modelClassName) throws Exception {
        IUserDetailOper detailOper = null;
        final String sysAttMainName = SysAttMain.class.getName();
        if (!UserOperHelper.isMechesUsedModelName(ModelUtil.getModelClassName((Object)modelClassName))) {
            if (SysAttachmentCoreOuterService.logger.isDebugEnabled()) {
                SysAttachmentCoreOuterService.logger.debug("当前操作对应的主文档类型与机制对应的主文档不一致, 不记录本次机制操作日志");
            }
        }
        else {
            final IUserOper oper4Mechs = UserOperConvertHelper.createOper4Mechs("attachment", modelId, (String)null, (String)null, sysAttMainName);
            detailOper = oper4Mechs.createOper4Detail("attachments", sysAttMainName);
        }
        for (final String key : forms.keySet()) {
            if (key != null) {
                final AttachmentDetailsForm attachmentForm = forms.get(key);
                if (StringUtil.isNotNull(attachmentForm.getDeletedAttachmentIds())) {
                    final String[] ids = attachmentForm.getDeletedAttachmentIds().split(";");
                    if (ids.length > 0) {
                        final List<SysAttMain> sysAttMains = this.getSysAttMainService().findByPrimaryKeys(ids);
                        for (final SysAttMain attMain : sysAttMains) {
                            boolean deleted = false;
                            if (StringUtil.isNotNull(attMain.getFdModelId()) && StringUtil.isNotNull(attMain.getFdModelName())) {
                                if (attMain.getFdModelId().equals(modelId) && attMain.getFdModelName().equals(modelClassName)) {
                                    deleted = true;
                                }
                            }
                            else if (StringUtil.isNull(attMain.getFdModelName())) {
                                if (StringUtil.isNull(attMain.getFdModelId())) {
                                    deleted = true;
                                }
                                else if (attMain.getFdModelId().equals(modelId)) {
                                    deleted = true;
                                }
                            }
                            else if (StringUtil.isNull(attMain.getFdModelId()) && attMain.getFdModelName().equals(modelClassName)) {
                                deleted = true;
                            }
                            if (deleted) {
                                this.getSysAttMainService().delete((IBaseModel)attMain);
                                if (detailOper == null) {
                                    continue;
                                }
                                detailOper.putDelete(attMain.getFdId(), attMain.getFdFileName());
                            }
                        }
                    }
                }
                if (attachmentForm.getAttachmentIds() == null) {
                    continue;
                }
                final String[] ids = attachmentForm.getAttachmentIds().split(";");
                final Map<String, Boolean> idHave = new HashMap<String, Boolean>();
                for (int i = 0; i < ids.length; ++i) {
                    if (ids[i] != null) {
                        if (ids[i].trim().length() != 0) {
                            if (idHave.get(ids[i]) != null) {
                                if (SysAttachmentCoreOuterService.logger.isDebugEnabled()) {
                                    SysAttachmentCoreOuterService.logger.debug(String.format("当前操作附件重复，ID:%s", ids[i]));
                                }
                            }
                            else {
                                idHave.put(ids[i], true);
                                if (this.getSysAttMainService().getBaseDao().isExist(SysAttMain.class.getName(), ids[i])) {
                                    final SysAttMain sysAttMain = (SysAttMain)this.getSysAttMainService().findByPrimaryKey(ids[i]);
                                    if (sysAttMain != null) {
                                        sysAttMain.setFdKey(key);
                                        sysAttMain.setFdModelId(modelId);
                                        sysAttMain.setFdModelName(modelClassName);
                                        sysAttMain.setInputStream((InputStream)null);
                                        sysAttMain.setFdOrder(Integer.valueOf(i));
                                        sysAttMain.setAddQueue(attachmentForm.getAddQueue());
                                        if (detailOper != null) {
                                            detailOper.putUpdate(sysAttMain.getFdId(), sysAttMain.getFdFileName());
                                        }
                                        this.getSysAttMainService().update((IBaseModel)sysAttMain);
                                    }
                                }
                                else if (SysAttachmentCoreOuterService.logger.isDebugEnabled()) {
                                    SysAttachmentCoreOuterService.logger.debug(String.format("当前操作附件为空，ID:%s", ids[i]));
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    
    private void addAttachment(final IAttachment form, final IAttachment model, final String fdKey, final boolean keyIsNullGetAll) throws Exception {
        if (model == null) {
            return;
        }
        if (!Hibernate.isInitialized((Object)form)) {
            Hibernate.initialize((Object)form);
        }
        final Map attForms = (Map)form.getAttachmentForms();
        final String modelClassName = ModelUtil.getModelClassName((Object)model);
        final String modelId = BeanUtils.getProperty((Object)model, "fdId");
        final List atts = ((ISysAttMainCoreInnerDao)this.getSysAttMainService().getBaseDao()).findAttListByModel(modelClassName, modelId);
        boolean isValidate = true;
        if (keyIsNullGetAll && StringUtil.isNull(fdKey)) {
            isValidate = false;
        }
        for (final SysAttMain sysAttMain : atts) {
            if (isValidate && !sysAttMain.getFdKey().equals(fdKey)) {
                continue;
            }
            final AttachmentDetailsForm attForm = attForms.get(sysAttMain.getFdKey());
            attForm.setFdModelId(modelId);
            attForm.setFdModelName(modelClassName);
            attForm.setFdKey(sysAttMain.getFdKey());
            if (!attForm.getAttachments().contains((Object)sysAttMain)) {
                attForm.getAttachments().add((Object)sysAttMain);
            }
            final String attids = attForm.getAttachmentIds();
            if (StringUtil.isNull(attids)) {
                attForm.setAttachmentIds(sysAttMain.getFdId());
            }
            else {
                attForm.setAttachmentIds(String.valueOf(sysAttMain.getFdId()) + ";" + attids);
            }
        }
    }
    
    private Map getCloneAttachmentMapForModel(final IAttachment attachment, final String targetModelName, final IBaseModel model, final String fdKey, final boolean keyIsNullGetAll) throws Exception {
        IAttachment att = null;
        String modelId = null;
        Map attForms = null;
        Iterator keys = null;
        String modelClassName = targetModelName;
        if (model == null) {
            att = (IAttachment)new Attachment();
        }
        else {
            att = (IAttachment)model;
            if (StringUtil.isNull(modelClassName)) {
                modelClassName = ModelUtil.getModelClassName((Object)model);
            }
            modelId = model.getFdId();
        }
        final int p = modelClassName.indexOf("$");
        if (p > -1) {
            modelClassName = modelClassName.substring(0, p);
        }
        if (StringUtil.isNull(fdKey) && keyIsNullGetAll) {
            this.addAttachment(att, attachment);
            attForms = (Map)att.getAttachmentForms();
            keys = attForms.keySet().iterator();
        }
        else {
            this.addAttachment(att, attachment, fdKey);
            attForms = (Map)att.getAttachmentForms();
            final List tmpKeys = new ArrayList();
            tmpKeys.add(fdKey);
            keys = tmpKeys.iterator();
        }
        final Iterator iterator = keys;
        while (iterator.hasNext()) {
            final String key = iterator.next();
            final AttachmentDetailsForm attForm = attForms.get(key);
            attForm.setFdModelName(modelClassName);
            attForm.setFdKey(key);
            final List atts = (List)attForm.getAttachments();
            String attids = "";
            final AutoArrayList attachments = new AutoArrayList((Class)SysAttMain.class);
            final Iterator iter = atts.iterator();
            while (iter.hasNext()) {
                SysAttMain sysAttMain = iter.next();
                if ("historyVersionAttachment".equals(sysAttMain.getFdKey())) {
                    continue;
                }
                sysAttMain = this.getSysAttMainService().clone(sysAttMain);
                sysAttMain.setFdVersion(Integer.valueOf(1));
                sysAttMain.setFdModelId(modelId);
                if (model != null) {
                    sysAttMain.setFdModelName(modelClassName);
                }
                attids = String.valueOf(attids) + sysAttMain.getFdId().toString();
                if (iter.hasNext()) {
                    attids = String.valueOf(attids) + ";";
                }
                attachments.add((Object)sysAttMain);
            }
            attForm.setAttachments(attachments);
            attForm.setAttachmentIds(attids);
        }
        this.getSysAttMainService().flushHibernateSession();
        if (StringUtil.isNull(fdKey) && keyIsNullGetAll) {
            return (Map)att.getAttachmentForms();
        }
        final Map newAttForms = new HashMap();
        newAttForms.put(fdKey, attForms.get(fdKey));
        return newAttForms;
    }
    
    class Attachment implements IAttachment
    {
        public AutoHashMap attachmentForms;
        
        Attachment() {
            this.attachmentForms = new AutoHashMap((Class)AttachmentDetailsForm.class);
        }
        
        public AutoHashMap getAttachmentForms() {
            return this.attachmentForms;
        }
        
        public void setAttachmentForms(final AutoHashMap attachmentForms) {
            this.attachmentForms = attachmentForms;
        }
    }
}
